      SUBROUTINE derivs(time,w,f)
c
c  subroutine to calculate the 
C  derivatives
c
      REAL time,w(12),f(12)	
	REAL ma,mb
	integer i
	REAL r0, well, range,JAB, rab,QAB
	common /potent/r0, well, range, JAB, rAB,QAB
	COMMON /masses/ma,mb
C Assume a morse potential, i.e.
C	VAB= well*(exp(-2.*(rAB-r0)/range)
C	1   -2*exp(-(rAB-r0)/range) )

	rAB=sqrt( (w(1)-w(4))**2 +
	1 (w(2)-w(5))**2 +
	2 (w(3)-w(6))**2 )
	

	QAB= 2*well/range*(exp(-(rAB-r0)/range)
	1    -exp(-2*(rAB-r0)/range) )/rab


	do 10 i=1,6
	f(i)=w(i+6)
 10	enddo

      do 20 i=7,9
	f(i)= QAB*(w(i-3)-w(i-6))/ma
 20	enddo
	do 30 i=10,12
	f(i)= QAB*(w(i-9)-w(i-6))/mb
 30	continue
     
      return
      END



      SUBROUTINE jacobn(time,w,dfdt,dfdw,n,nmax)
      INTEGER n,nmax,i

      REAL time,w(*),dfdt(*),dfdw(nmax,nmax)
	REAL r0, well, range,JAB, rab,QAB
	common /potent/r0, well, range, JAB, rAB,QAB
	COMMON /masses/ma,mb


	do 15 i=1,n
        dfdt(i)=0.
	do 11 j=1,n
	 dfdw(i,j)=0.0
 11    enddo
 15	 enddo


	rAB=( (w(1)-w(4))**2 + 
	1 (w(2)-w(5))**2 +
	2 (w(3)-w(6))**2 )
	rAb=sqrt(rab)
	QAB= 2.*well/range*(
	1 exp(-(rAB-r0)/range)
	2 -exp(-2*(rAB-r0)/range) )/rAB
	JAB= 2.*well/range/range*(
	1 -exp(-(rAB-r0)/range)
	2 +2.*exp(-2*(rAB-r0)/range) 
     3 )/rAB/rAB-QAB/rAB
	do 20 i=1,6
	dfdw(i,i+6)=1.
  20	enddo
	do 30 i=7,9
	do 29 j=1,3
	dfdw(i,j)= JAB*(w(i-3)-w(i-6))/ma
	1 *(w(j)-w(j+3))
	dfdw(i,j+3)= JAB*(w(i-3)-w(i-6))/ma
	1 *(w(j+3)-w(j))
  29	enddo
	dfdw(i,i-3)=dfdw(i,i-3)+QAB/ma
	dfdw(i,i-6)=dfdw(i,i-6) -QAB/ma
  30	enddo
	do 40 i=10,12
	do 39 j=1,3
	dfdw(i,j)= JAB*(w(i-9)-w(i-6))/ma
	1 *(w(j)-w(j+3))
	dfdw(i,j+3)= JAB*(w(i-9)-w(i-6))/ma
	1 *(w(j+3)-w(j))
  39	enddo
	dfdw(i,i-9)=dfdw(i,i-9)+QAB/mb
	dfdw(i,i-6)=dfdw(i,i-6)-QAB/mb
 40	enddo		 
      return
      END


